#ifndef _LOMAC_MEDIATE_H_
#define _LOMAC_MEDIATE_H_

/*************************************************************************
 *
 * lomac_mediate.h
 *
 * LOMAC - Low Water-Mark Mandatory Access Control for Linux 
 * Copyright (c) 1999-2001 NAI Labs, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 * 
 *   Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 * 
 *   Neither the name of NAI Labs, Inc. nor the names of its contributors
 *   may be used to endorse or promote products derived from this software
 *   without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *************************************************************************/

#include "kernel_interface.h"

int mediate_subject_subject( const char *op_s,
			     const lomac_subject_t *p_subject_one, 
			     const lomac_subject_t *p_subject_two );
int mediate_subject_path( const char *op_s, const lomac_subject_t *p_subject,
			  const char *path_s );
int mediate_subject_object( const char *op_s, const lomac_subject_t *p_subject,
			    const lomac_object_t *p_object );
int mediate_path_path( const char *op_s, const lomac_subject_t *p_subject,
		       const char *canabsname_one_s, 
		       const char *canabsname_two_s );
int mediate_subject_subject( const char *op_s, 
			     const lomac_subject_t *p_subject,
			     const lomac_subject_t *p_target );
int mediate_subject_at_lattr( const char *op_s, 
			      const lomac_subject_t *p_subject,
			      const lattr_t target_lattr );
int mediate_object_at_lattr( const char *op_s,
			     const lomac_subject_t *p_subject,
			     const lomac_object_t *p_object,
			     const lattr_t target_lattr );

#endif
