#!/usr/local/bin/ruby
# $Id: lomac.rb,v 1.3 2001/08/31 20:19:16 bfeldman Exp $
class Lomac
	LEVEL_NUMTONAME = { 1 => :lowest, 2 => :highest }
	def initialize
		@dev = File.open('/dev/lomac')
	end
	if PLATFORM =~ /linux/
		def file_level(fname)
			fname = fname.to_str.concat(0.chr)
			LEVEL_NUMTONAME[@dev.ioctl(1,
			  [fname.length, fname].pack('Ia*'))]
		end
		def process_level(pid)
			LEVEL_NUMTONAME[@dev.ioctl(0, pid.to_i)]
		end
	else
		require 'ioccom'
		MAXPATHLEN = 1024
		LIOGETPLEVEL = Ioccom::_IOWR('L', 0, [0].pack('I'))
		def process_level(pid)
			storage = [pid].pack('I')
			@dev.ioctl(LIOGETPLEVEL, storage)
			LEVEL_NUMTONAME[storage.unpack('I')[0]]
		end
		LIOGETFLEVEL = Ioccom::_IOWR('L', 1,
		    ("\0" * MAXPATHLEN) + [0].pack('I'))
		def file_level(path)
			storage = ("\0" * MAXPATHLEN) + [0].pack('I')
			len = [MAXPATHLEN - 1, path.length].min
			storage[0, len] = path[0, len]
			@dev.ioctl(LIOGETFLEVEL, storage)
			LEVEL_NUMTONAME[storage[MAXPATHLEN..-1].unpack('I')[0]]
		end
		LIOPMAKELOWLEVEL = Ioccom::_IO('L', 2)
		def make_low_level
			@dev.ioctl(LIOPMAKELOWLEVEL)
		end
	end
end
